#include <ctype.h>
#include "Global.h"
#include "Util.h"
#include "Object.h"
#include "Interface.h"
#include "Hero.h"

static int
useBizarroOrgasmatron (shObject *obj)
{
    if (Level->isMainframe ()) {
        I->p ("Indeed, this is the Bizarro Orgasmatron!");
        I->p ("However, to make real use of its power you must escape the Mainframe.");
        obj->setIlkKnown ();
        return FULLTURN;
    }
    I->p ("Hot dog!  You finally got your paws on the Bizarro Orgasmatron!");
    I->p ("You use its awesome power to beam yourself off this two-bit space hulk.");
    I->p ("");

    Hero.earnScore (10000);
    Hero.die (kWonGame);
    return FULLTURN;
}


static int
useBizarreOrgasmatron (shObject *obj)
{
    I->p ("Hot dog!  You finally got your paws on the Bizarre Orgasmatron!");
    I->p ("You use its awesome power to beam yourself off this two-bit space hulk.");
    I->p ("");
    I->pause ();

    if (Hero.countEnergy () > 15) {
        Hero.loseEnergy (15);
        if (Hero.transport (-1, -1, 100, 1)) {
            Hero.die (kKilled, "the power of the Bizarre Orgasmatron");
            return FULLTURN;
        }
    }
    I->p ("Hrmm... that's bizarre...");
    obj->setIlkKnown ();
    return FULLTURN;
}


static int
useBizaaroOrgasmatron (shObject *obj)
{
    I->p ("You activate the Bizaaro Orgasmatron...");
    I->pause ();
    I->p ("An invisible choir sings, and you are bathed in radiance...");
    I->pause ();
    I->p ("The voice of eit_cyrus booms out:");
    I->setColor (kBrightGreen);
    I->p ("\"CoGNRATULATOINSS, n00B!!!\"");
    I->pause ();
    I->p ("\"In retrun  for thy sevrice, I grants thee teh gift of a SPELLCHEECKER!!!\"");
    I->p ("\"HAHAHAHAHOHOHOAHAHAHA!!! !!!!!1\"");
    I->setColor (kGray);

    obj->setIlkKnown ();
    return FULLTURN;
}


static int
useBizzaroOrgasmatron (shObject *obj)
{
    I->p ("This makes you feel great!");
    obj->setIlkKnown ();
    return FULLTURN;
}


static int
useBazaaroOrgasmatron (shObject *obj)
{
    I->p ("Nothing happens.");
    obj->setIlkKnown ();
    return FULLTURN;
}


static int
useBazarroOrgasmatron (shObject *obj)
{
    char *capsname = strdup (Hero.mName);
    char *p;

    for (p = capsname; *p; p++)
        *p = toupper (*p);
    I->p ("THANK YOU %s!", capsname);
    I->p ("BUT OUR PRINCESS IS IN ANOTHER CASTLE!");
    free (capsname);
    obj->setIlkKnown ();
    return FULLTURN;
}


void
initializeArtifacts ()
{
    /* enum: kObjTransfunctioner */
    NEW_TOOL(kObjTransfunctioner,
        "Continuum Transfunctioner", "Rubik's Cube", "Rubik's Cube",
        kRed, kObjNothing, 1000000, kPlastic,
        kUnique, 500, kTiny, 100, 100,
        25, 0, NULL, 0);

    /* enum: kObjTheOrgasmatron */
    NEW_TOOL(kObjTheOrgasmatron,
        "Bizarro Orgasmatron", "Orgasmatron", "Bizarro Orgasmatron",
        kBrightMagenta, kObjNothing, 1000000, kPlastic,
        kUnique | kIndestructible | kPreidentified | kBugProof, 500, kMedium, 100, 100,
        25, 0, &useBizarroOrgasmatron, 0);


    /* enum: kObjFakeOrgasmatron1 */
    NEW_TOOL(kObjFakeOrgasmatron1,
        "Bizarre Orgasmatron", "Orgasmatron", "Bizarre Orgasmatron",
        kBrightMagenta, kObjNothing, 1000000, kPlastic,
        kUnique | kIndestructible | kPreidentified | kBugProof, 500, kMedium, 100, 100,
        25, 0, &useBizarreOrgasmatron, 0);

    /* enum: kObjFakeOrgasmatron2 */
    NEW_TOOL(kObjFakeOrgasmatron2,
        "Bizaaro Orgasmatron", "Orgasmatron", "Bizaaro Orgasmatron",
        kBrightMagenta, kObjNothing, 1000000, kPlastic,
        kUnique | kIndestructible | kPreidentified | kBugProof, 500, kMedium, 100, 100,
        25, 0, &useBizaaroOrgasmatron, 0);

    /* enum: kObjFakeOrgasmatron3 */
    NEW_TOOL(kObjFakeOrgasmatron3,
        "Bizzaro Orgasmatron", "Orgasmatron", "Bizzaro Orgasmatron",
        kBrightMagenta, kObjNothing, 1000000, kPlastic,
        kUnique | kIndestructible | kPreidentified | kBugProof, 500, kMedium, 100, 100,
        25, 0, &useBizzaroOrgasmatron, 0);

    /* enum: kObjFakeOrgasmatron4 */
    NEW_TOOL(kObjFakeOrgasmatron4,
        "Bazaaro Orgasmatron", "Orgasmatron", "Bazaaro Orgasmatron",
        kBrightMagenta, kObjNothing, 1000000, kPlastic,
        kUnique | kIndestructible | kPreidentified | kBugProof, 500, kMedium, 100, 100,
        25, 0, &useBazaaroOrgasmatron, 0);

    /* enum: kObjFakeOrgasmatron5 */
    NEW_TOOL(kObjFakeOrgasmatron5,
        "Bazarro Orgasmatron", "Orgasmatron", "Bazarro Orgasmatron",
        kBrightMagenta, kObjNothing, 1000000, kPlastic,
        kUnique | kIndestructible | kPreidentified | kBugProof, 500, kMedium, 100, 100,
        25, 0, &useBazarroOrgasmatron, 0);
}
